const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const job_templates = sequelize.define(
    'job_templates',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

default_price: {
        type: DataTypes.DECIMAL,
      
      

      },

default_duration_minutes: {
        type: DataTypes.INTEGER,
      
      

      },

default_instructions: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  job_templates.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























//end loop



    db.job_templates.belongsTo(db.workspaces, {
      as: 'workspace',
      foreignKey: {
        name: 'workspaceId',
      },
      constraints: false,
    });

    db.job_templates.belongsTo(db.service_catalog_items, {
      as: 'service_catalog_item',
      foreignKey: {
        name: 'service_catalog_itemId',
      },
      constraints: false,
    });

    db.job_templates.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.job_templates.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.job_templates.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return job_templates;
};


